from winim/inc\commctrl import Edit_SetCueBannerText  
from winim/inc\shellapi import ShellExecute
include winim/[inc\winuser]
import wnim, os, parsecfg, tables

#========== procedures ==============================================
# Rückgabe des aktuellen (Anwendungs-) Verzeichnisses
proc CurrentDir*(): string =
  result = getAppFilename().splitPath().head

# Rückgabe einer Sektion aus einer mit "loadConfig" geladenen Ini-Datei
proc Section*(ini: Config, sec: string): OrderedTableRef[string,string] =
  var res = newOrderedTable[string, string]()
  if ini.hasKey(sec): result = ini[sec]
  else: result = res

# Rückgabe des Wertes für einen Schlüssel aus einer Sektion
proc Key*(sec: OrderedTableRef[string,string], key: string, 
         def_val: string = ""): string =
  if sec.hasKey(key): result = sec[key]
  else: result = def_val 

# Setzt CueBanner-Text in ein TextCtrl
proc TextCtrlSetCueBanner*(ctrl: wTextCtrl, cuetext: string) =
  let cs_cuetext = newWideCString(cuetext, cuetext.len)
  Edit_SetCueBannerText(ctrl.handle, cast[LPWSTR](cs_cuetext))

# Anzeigen einer MessageBox
proc MessageBox*(frame: wFrame, text: string, caption: string, 
                uType: UINT): int32 {.discardable.} =
  let
    lptext = newWideCString(text, text.len)
    lpcaption = newWideCString(caption, caption.len)
  result = frame.handle.MessageBox(cast[LPCWSTR](lptext), 
                        cast[LPCWSTR](lpcaption), uType)

# Erstellt ein StaticBitmap als Button, Auswertung: .wEvent_CommandLeftClick
# works with: *.ico / *.png / *.bmp / *.jpg
# Styles:
#   wBorderStatic:  leicht abgesenkt
#   wBorderSimple:  dünner Rand
#   wBorderRaised:  erhaben (intern: wBorderDouble)
#   wBorderSunken:  abgesenkt
proc BitmapButton*(hwnd: wWindow, source: string, pos: wPoint=wDefaultPoint, 
                  size: wSize=wDefaultSize, style: wStyle=wSbAuto): wStaticBitmap =
  let bmp = source.Image().scale(size=size).Bitmap()
  var used_style = style
  if style == wBorderRaised: used_style = wBorderDouble
  elif style == wBorderDouble: used_style = wBorderSimple
  result = hwnd.StaticBitmap(pos=pos, size=size, bitmap=bmp, style=used_style)  

# gecoverte Form von ShellExecute für Parameter-Typ: string
proc MyShellExecute*(hwnd: HWND = 0, operation: string = "", file: string,
                    param: string = "", dir: string = "", 
                    show: INT = SW_SHOW): HINSTANCE {.discardable.} =
  proc PointerOrNil(a: WideCStringObj): LPCWSTR = 
    if a == nil: result = nil
    else: result = cast[LPCWSTR](addr a[0])
  var 
    o_cs: WideCStringObj = nil 
    f_cs: WideCStringObj = newWideCString(file & chr(0),file.len + 1)
    p_cs: WideCStringObj = nil 
    d_cs: WideCStringObj = nil
  if operation != "":o_cs = newWideCString(operation & chr(0),operation.len + 1)
  if param != "": p_cs = newWideCString(param & chr(0),param.len + 1)
  if dir != "": d_cs = newWideCString(dir & chr(0),dir.len + 1)
  result = ShellExecute(hwnd, o_cs.PointerOrNil(), f_cs.PointerOrNil(), 
                        p_cs.PointerOrNil(), d_cs.PointerOrNil(), show)                       
#====================================================================